#include "webui.h"

AsyncWebServer webServer(80);

const char *PARAM_MESSAGE = "message";

String processor(const String &var);
void WebserverPost_Callback(AsyncWebServerRequest *request);
void WebserverNotFound_Callback(AsyncWebServerRequest *request);

void initWebUI()
{
  if (!LittleFS.begin())
  {
    Serial.println("An Error has occurred while mounting LittleFS");
    return;
  }

  // Route to load style.css file
  webServer.serveStatic("/", LittleFS, "/").setDefaultFile("index.htm");
  webServer.onNotFound(WebserverNotFound_Callback);

  webServer.on("/index.htm", HTTP_GET, [](AsyncWebServerRequest *request)
               { request->send(LittleFS, "/index.htm", String(), false, processor); });

  webServer.on("/", HTTP_POST, WebserverPost_Callback);

  webServer.begin();
}

void UpdateWebUI()
{
}

String processor(const String &var)
{

  if (var == "PLACEHOLDER")
    return "placeholder";

  return String();
}

void WebserverPost_Callback(AsyncWebServerRequest *request)
{
  String message;
  if (request->hasParam(PARAM_MESSAGE, true))
  {
    message = request->getParam(PARAM_MESSAGE, true)->value();
    Serial.printf("POST: %s", message);
  }
}

void WebserverNotFound_Callback(AsyncWebServerRequest *request)
{
  request->send(404, "text/plain", "Not found");
}